#include "Main.h"

ConceptionApp::ConceptionApp(InputManager & InputManager)
	: App(InputManager),
	  m_CurrentProject()
{
	{
		auto MainCanvas = new Canvas(Vector2n(0, 0), true, true);

		MainCanvas->AddWidget(new ListWidget(Vector2n(-200, -300), m_CurrentProject.GetStdIncludes()));
		MainCanvas->AddWidget(new ButtonWidget(Vector2n(100, -300)));
		MainCanvas->AddWidget(new ButtonWidget(Vector2n(140, -300)));
		MainCanvas->AddWidget(new TextFieldWidget(Vector2n(-400, 0)));
		MainCanvas->AddWidget(new ConceptStringBoxWidget(Vector2n(-400, -100)));

		m_Widgets.push_back(std::unique_ptr<Widget>(MainCanvas));
	}

	{
		PopulateConcepts();

		// Load program
		m_CurrentProject.LoadSampleGenProgram(*static_cast<Canvas *>(m_Widgets[0].get()));
	}
}

ConceptionApp::~ConceptionApp()
{
}

void ConceptionApp::UpdateWindowDimensions(Vector2n WindowDimensions)
{
	// TODO: This is a hack, I should create a WindowResize listener type of thing and take care within Widget itself
	static_cast<Canvas *>(m_Widgets[0].get())->SetDimensions(WindowDimensions);
}
