#include "../Main.h"

// TODO: I've made this into a multi-line edit box, so change class name from Field (i.e. 1 line) to Box
TextFieldWidget::TextFieldWidget(Vector2n Position)
	: Widget(Position, Vector2n(904, (3 + 2/*f.body_lines.size()*/) * lineHeight)),
	  m_Content(),
	  m_ContentLines(),
	  m_MaxLineLength(0),
	  m_CaretPosition(0),
	  m_SelectionPosition(0)
{
	ModifyGestureRecognizer().m_RecognizeTap = true;
}

TextFieldWidget::~TextFieldWidget()
{
}

void TextFieldWidget::Render()
{
	Color BackgroundColor(1, 1, 1);
	Color BorderColor(0.3, 0.3, 0.3);

	/*if (CheckHover(WidgetManager) && CheckActive(WidgetManager))
	{
	}
	else if ((CheckHover(WidgetManager) && !CheckAnyActive(WidgetManager)) || (!CheckHover(WidgetManager) && CheckActive(WidgetManager)))
	{
		BorderColor[0] = 0.898;
		BorderColor[1] = 0.765;
		BorderColor[2] = 0.396;
	}
	else
	{
	}*/
	//if (CheckHover())
	// HACK
	if (   !ModifyGestureRecognizer().GetConnected().empty()
		&& ModifyGestureRecognizer().GetConnected().end() != ModifyGestureRecognizer().GetConnected().find(g_InputManager->m_TypingPointer.get()))
	{
		BorderColor[0] = 0.898;
		BorderColor[1] = 0.765;
		BorderColor[2] = 0.396;
	}

	/*glBegin(GL_QUADS);
		glVertex2d(m_Position.X(), m_Position.Y());
		glVertex2d(m_Position.X(), m_Position.Y() + 30);
		glVertex2d(m_Position.X() + 30, m_Position.Y() + 30);
		glVertex2d(m_Position.X() + 30, m_Position.Y());
	glEnd();*/
	DrawBox(m_Position, m_Dimensions, BackgroundColor, BorderColor);

	glColor3d(0, 0, 0);
	OpenGLStream OpenGLStream(m_Position);
	OpenGLStream << m_Content.substr(0, std::min(m_CaretPosition, m_SelectionPosition));

	auto SelectionLength = std::max(m_CaretPosition, m_SelectionPosition) - std::min(m_CaretPosition, m_SelectionPosition);

	//if (CheckHover())
	// HACK
	if (   !ModifyGestureRecognizer().GetConnected().empty()
		&& ModifyGestureRecognizer().GetConnected().end() != ModifyGestureRecognizer().GetConnected().find(g_InputManager->m_TypingPointer.get()))
	{
		{
			std::string Line = m_Content.substr(std::min(m_CaretPosition, m_SelectionPosition), SelectionLength);

			uint32 CaretPositionX = OpenGLStream.GetCaretPosition().X() - m_Position.X();
			std::string::size_type Start = 0, End;
			do
			{
				End = Line.find_first_of('\t', Start);

				auto Length = ((std::string::npos != End) ? End : Line.length()) - Start;
				//PrintSegment(Line.substr(Start, Length));
				CaretPositionX += Length * charWidth;
				if (std::string::npos != End)
				{
					//Tab();
					CaretPositionX = ((CaretPositionX / charWidth / 4) + 1) * 4 * charWidth;
				}

				Start = End + 1;
			}
			while (std::string::npos != End);

			DrawInnerBox(OpenGLStream.GetCaretPosition(), Vector2n(CaretPositionX - (OpenGLStream.GetCaretPosition().X() - m_Position.X()), lineHeight), Color(233 / 255.0, 239 / 255.0, 250 / 255.0), Color(195 / 255.0, 212 / 255.0, 242 / 255.0));
		}

		//if (static_cast<int>(glfwGetTime() * 2) % 2)
		if (true)
		{
			if (std::min(m_CaretPosition, m_SelectionPosition) == m_CaretPosition)
			{
				glPushMatrix();
				glTranslated(OpenGLStream.GetCaretPosition().X(), OpenGLStream.GetCaretPosition().Y(), 0);
				glColor3d(0, 0, 0);
				glBegin(GL_QUADS);
					glVertex2d(-1, 0);
					glVertex2d(-1, lineHeight);
					glVertex2d(+1, lineHeight);
					glVertex2d(+1, 0);
				glEnd();
				glPopMatrix();
			}
		}
	}

	OpenGLStream << m_Content.substr(std::min(m_CaretPosition, m_SelectionPosition), SelectionLength);

	//if (CheckHover())
	// HACK
	if (   !ModifyGestureRecognizer().GetConnected().empty()
		&& ModifyGestureRecognizer().GetConnected().end() != ModifyGestureRecognizer().GetConnected().find(g_InputManager->m_TypingPointer.get()))
	{
		//if (static_cast<int>(glfwGetTime() * 2) % 2)
		if (true)
		{
			if (std::max(m_CaretPosition, m_SelectionPosition) == m_CaretPosition)
			{
				glPushMatrix();
				glTranslated(OpenGLStream.GetCaretPosition().X(), OpenGLStream.GetCaretPosition().Y(), 0);
				glColor3d(0, 0, 0);
				glBegin(GL_QUADS);
					glVertex2d(-1, 0);
					glVertex2d(-1, lineHeight);
					glVertex2d(+1, lineHeight);
					glVertex2d(+1, 0);
				glEnd();
				glPopMatrix();
			}
		}
	}

	OpenGLStream << m_Content.substr(std::max(m_CaretPosition, m_SelectionPosition));
}

void TextFieldWidget::ProcessTap()
{
	g_InputManager->RequestTypingPointer(ModifyGestureRecognizer());
}

void TextFieldWidget::ProcessCharacter(const int Character)
{
	if (static_cast<uint32>(Character) < 128)
	{
		auto SelectionLength = std::max(m_CaretPosition, m_SelectionPosition) - std::min(m_CaretPosition, m_SelectionPosition);

		if (m_CaretPosition != m_SelectionPosition)
		{
			m_Content.erase(std::min(m_CaretPosition, m_SelectionPosition), SelectionLength);
			m_CaretPosition = std::min(m_CaretPosition, m_SelectionPosition);
			m_SelectionPosition = std::min(m_CaretPosition, m_SelectionPosition);
		}

		m_Content.insert(m_CaretPosition, 1, static_cast<uint8>(Character));
		++m_CaretPosition;
		++m_SelectionPosition;
	}
}

void TextFieldWidget::ProcessEvent(InputEvent & InputEvent)
{
	auto SelectionLength = std::max(m_CaretPosition, m_SelectionPosition) - std::min(m_CaretPosition, m_SelectionPosition);

	if (InputEvent.m_EventTypes.end() != InputEvent.m_EventTypes.find(InputEvent::EventType::BUTTON_EVENT))
	{
		if (Pointer::VirtualCategory::TYPING == InputEvent.m_Pointer->GetVirtualCategory())
		{
			auto ButtonId = InputEvent.m_InputId;
			bool Pressed = InputEvent.m_Buttons[0];		// TODO: Check if there are >1 buttons

			if (Pressed)
			{
				switch (ButtonId)
				{
				case GLFW_KEY_BACKSPACE:
					{
						if (m_CaretPosition == m_SelectionPosition)
						{
							if (m_CaretPosition > 0)
							{
								m_Content.erase(m_CaretPosition - 1, 1);
								--m_CaretPosition;
								--m_SelectionPosition;
							}
						}
						else
						{
							m_Content.erase(std::min(m_CaretPosition, m_SelectionPosition), SelectionLength);
							m_CaretPosition = std::min(m_CaretPosition, m_SelectionPosition);
							m_SelectionPosition = std::min(m_CaretPosition, m_SelectionPosition);
						}
					}
					break;
				case GLFW_KEY_DEL:
					{
						if (m_CaretPosition == m_SelectionPosition)
						{
							if (m_CaretPosition < m_Content.length())
							{
								m_Content.erase(m_CaretPosition, 1);
							}
						}
						else
						{
							m_Content.erase(std::min(m_CaretPosition, m_SelectionPosition), SelectionLength);
							m_CaretPosition = std::min(m_CaretPosition, m_SelectionPosition);
							m_SelectionPosition = std::min(m_CaretPosition, m_SelectionPosition);
						}
					}
					break;
				case GLFW_KEY_ENTER:
				case GLFW_KEY_KP_ENTER:
					{
						if (m_CaretPosition != m_SelectionPosition)
						{
							m_Content.erase(std::min(m_CaretPosition, m_SelectionPosition), SelectionLength);
							m_CaretPosition = std::min(m_CaretPosition, m_SelectionPosition);
							m_SelectionPosition = std::min(m_CaretPosition, m_SelectionPosition);
						}

						m_Content.insert(m_CaretPosition, 1, '\n');
						++m_CaretPosition;
						++m_SelectionPosition;
					}
					break;
				case GLFW_KEY_TAB:
					{
						if (m_CaretPosition != m_SelectionPosition)
						{
							m_Content.erase(std::min(m_CaretPosition, m_SelectionPosition), SelectionLength);
							m_CaretPosition = std::min(m_CaretPosition, m_SelectionPosition);
							m_SelectionPosition = std::min(m_CaretPosition, m_SelectionPosition);
						}

						m_Content.insert(m_CaretPosition, 1, '\t');
						++m_CaretPosition;
						++m_SelectionPosition;
					}
					break;
				case GLFW_KEY_LEFT:
					{
						if (m_CaretPosition > 0)
						{
							--m_CaretPosition;
							if (!InputEvent.m_Pointer->GetPointerState().GetButtonState(GLFW_KEY_LSHIFT) && !InputEvent.m_Pointer->GetPointerState().GetButtonState(GLFW_KEY_RSHIFT))
							{
								m_SelectionPosition = m_CaretPosition;
							}
						}
					}
					break;
				case GLFW_KEY_RIGHT:
					{
						if (m_CaretPosition < m_Content.length())
						{
							++m_CaretPosition;
							if (!InputEvent.m_Pointer->GetPointerState().GetButtonState(GLFW_KEY_LSHIFT) && !InputEvent.m_Pointer->GetPointerState().GetButtonState(GLFW_KEY_RSHIFT))
							{
								m_SelectionPosition = m_CaretPosition;
							}
						}
					}
					break;
				case GLFW_KEY_UP:
					{
					}
					break;
				case GLFW_KEY_DOWN:
					{
					}
					break;
				default:
					break;
				}
			}
		}
		else if (Pointer::VirtualCategory::POINTING == InputEvent.m_Pointer->GetVirtualCategory())
		{
			auto ButtonId = InputEvent.m_InputId;
			bool Pressed = InputEvent.m_Buttons[0];		// TODO: Check if there are >1 buttons

			if (Pressed)
			{
				switch (ButtonId)
				{
				case 0:
					{
						Vector2n GlobalPosition(InputEvent.m_Pointer->GetPointerState().GetAxisState(0).GetPosition(), InputEvent.m_Pointer->GetPointerState().GetAxisState(1).GetPosition());
						Vector2n LocalPosition = GlobalToLocal(GlobalPosition);

						// Update Content Lines structure
						{
							m_ContentLines.clear();
							m_MaxLineLength = 0;

							std::string::size_type Start = 0, End;
							do
							{
								End = m_Content.find_first_of('\n', Start);

								auto Length = ((std::string::npos != End) ? End : m_Content.length()) - Start;
								m_ContentLines.push_back(ContentLine(Start, Length));
								if (m_MaxLineLength < Length)
									m_MaxLineLength = Length;

								Start = End + 1;
							}
							while (std::string::npos != End);
						}

						// Calculate nearest caret position
						uint32 LineNumber = LocalPosition.Y() / lineHeight;
						if (LineNumber > m_ContentLines.size() - 1)
							LineNumber = m_ContentLines.size() - 1;
						uint32 CharacterNumber = (LocalPosition.X() + charWidth / 2) / charWidth;
						if (CharacterNumber > m_ContentLines[LineNumber].m_Length)
							CharacterNumber = m_ContentLines[LineNumber].m_Length;
						{
							std::string Line = m_Content.substr(m_ContentLines[LineNumber].m_StartPosition, m_ContentLines[LineNumber].m_Length);

							uint32 CaretPositionX = 0;
							std::string::size_type Start = 0, End;
							do
							{
								End = Line.find_first_of('\t', Start);

								auto Length = ((std::string::npos != End) ? End : Line.length()) - Start;
								//PrintSegment(Line.substr(Start, Length));
								CaretPositionX += Length * charWidth;
								if (CaretPositionX >= LocalPosition.X())
								{
									CharacterNumber = Start + (LocalPosition.X() - (CaretPositionX - Length * charWidth) + charWidth / 2) / charWidth;
									break;
								}
								if (std::string::npos != End)
								{
									//Tab();
									auto StartCaretPositionX = CaretPositionX;
									CaretPositionX = ((CaretPositionX / charWidth / 4) + 1) * 4 * charWidth;
									if (CaretPositionX >= LocalPosition.X())
									{
										if (CaretPositionX - LocalPosition.X() > LocalPosition.X() - StartCaretPositionX)
											CharacterNumber = Start + Length;
										else
											CharacterNumber = Start + Length + 1;
										break;
									}
								}

								Start = End + 1;
							}
							while (std::string::npos != End);
						}

						m_CaretPosition = m_ContentLines[LineNumber].m_StartPosition + CharacterNumber;
						m_SelectionPosition = m_CaretPosition;
					}
					break;
				default:
					break;
				}
			}
		}
	}

	if (   InputEvent.m_EventTypes.end() != InputEvent.m_EventTypes.find(InputEvent::EventType::AXIS_EVENT)
		|| InputEvent.m_EventTypes.end() != InputEvent.m_EventTypes.find(InputEvent::EventType::CANVAS_MOVED_TEST))
	{
		if (Pointer::VirtualCategory::POINTING == InputEvent.m_Pointer->GetVirtualCategory())
		{
			if (InputEvent.m_Pointer->GetPointerState().GetButtonState(0))
			{
				Vector2n GlobalPosition(InputEvent.m_Pointer->GetPointerState().GetAxisState(0).GetPosition(), InputEvent.m_Pointer->GetPointerState().GetAxisState(1).GetPosition());
				Vector2n LocalPosition = GlobalToLocal(GlobalPosition);

				// Update Content Lines structure
				{
					m_ContentLines.clear();
					m_MaxLineLength = 0;
					
					std::string::size_type Start = 0, End;
					do
					{
						End = m_Content.find_first_of('\n', Start);

						auto Length = ((std::string::npos != End) ? End : m_Content.length()) - Start;
						m_ContentLines.push_back(ContentLine(Start, Length));
						if (m_MaxLineLength < Length)
							m_MaxLineLength = Length;

						Start = End + 1;
					}
					while (std::string::npos != End);
				}

				// Calculate nearest caret position
				uint32 LineNumber = LocalPosition.Y() / lineHeight;
				if (LineNumber > m_ContentLines.size() - 1)
					LineNumber = m_ContentLines.size() - 1;
				uint32 CharacterNumber = (LocalPosition.X() + charWidth / 2) / charWidth;
				if (CharacterNumber > m_ContentLines[LineNumber].m_Length)
					CharacterNumber = m_ContentLines[LineNumber].m_Length;
				{
					std::string Line = m_Content.substr(m_ContentLines[LineNumber].m_StartPosition, m_ContentLines[LineNumber].m_Length);

					uint32 CaretPositionX = 0;
					std::string::size_type Start = 0, End;
					do
					{
						End = Line.find_first_of('\t', Start);

						auto Length = ((std::string::npos != End) ? End : Line.length()) - Start;
						//PrintSegment(Line.substr(Start, Length));
						CaretPositionX += Length * charWidth;
						if (CaretPositionX >= LocalPosition.X())
						{
							CharacterNumber = Start + (LocalPosition.X() - (CaretPositionX - Length * charWidth) + charWidth / 2) / charWidth;
							break;
						}
						if (std::string::npos != End)
						{
							//Tab();
							auto StartCaretPositionX = CaretPositionX;
							CaretPositionX = ((CaretPositionX / charWidth / 4) + 1) * 4 * charWidth;
							if (CaretPositionX >= LocalPosition.X())
							{
								if (CaretPositionX - LocalPosition.X() > LocalPosition.X() - StartCaretPositionX)
									CharacterNumber = Start + Length;
								else
									CharacterNumber = Start + Length + 1;
								break;
							}
						}

						Start = End + 1;
					}
					while (std::string::npos != End);
				}

				m_CaretPosition = m_ContentLines[LineNumber].m_StartPosition + CharacterNumber;
			}
		}
	}
}
